<script>
  import generateDNA from "../assets/js/dna/generate";

  let sequence = "";

  function generate(event) {
    const form = event.target.parentNode.parentNode;
    const length = form.length.value;
    sequence = generateDNA(length);
    form.text.value = sequence;
    event.preventDefault();
  }

  function submitSequence(event) {
    const form = event.target.parentNode;
    const files = form.file.files;
    const file = files[0];
    if (file != undefined) {
      const reader = new FileReader();
      reader.onload = function (e) {
        console.log('file loaded');
        const text = e.target.result;
        sequence = text.toString().replace('\n', '');
        sendSequence(sequence);
      };
      reader.readAsText(file);
    } else {
      const data = new FormData(form);
      sequence = data.get('text').toString().replace('\n', '');
      sendSequence(sequence);
    }
    event.preventDefault();
  }
  export let sendSequence;
</script>

<div class="loader">
  <form>
    <fieldset>
      <legend>Submit a sequence file</legend>
      <input type="file" name="file" id="dna-file" placeholder="dna.fasta" />
      <label for="dna-file">Choose a text file</label>
    </fieldset>
    <fieldset>
      <legend>Or Paste a sequence file</legend>
      <textarea
        name="text"
        id="dna-text"
        cols="30"
        rows="10"
        placeholder="AATGCACTG..."
        value={sequence}
      />
    </fieldset>
    <fieldset>
      <legend>You can also Generate a random one</legend>
      <input type="number" name="length" id="dna-length">
      <label for="dna-length" value="100">Length</label>
      <button class="button generate" on:click={generate}>
        Generate
      </button>
    </fieldset>
    <input
      class="button"
      type="submit"
      value="Listen"
      on:click={submitSequence}
    />
  </form>
</div>
